
/* dia-canvas (c) sus dueños.
 * dia-canvas (c) it's owners.
 * dia-canvas-clipboard (c) 
 * Derechos reservados : RF-Labs. www.rflabs-online.com
 * Copyright (C) 2007 RF-Labs. www.rflabs-online.com
 * Ing. development:
 * Ing.Desarrollo Exell E. Franklin Jiménez.
 * Cumple con la licencia GNU 2 o superior.
 * GNULicense 2 or above.
 * Se basó en la biblioteca de gtkclipboard
 * based upon gtkclipboard
 * This librarie give gtkclipsupport to dia canvas objects
 * Esta biblioteca dá soporte de portapapeles a los objetos de dia-canvas
 */
#include "dia-canvas-clipboard.h"
#include "dia-shape.h"
#include "dia-canvas-element.h"
#include "dia-canvas-item.h"
#include "dia-placement-tool.h"
#include "dia-canvas-groupable.h"


typedef struct _RequestContentsInfo RequestContentsInfo;
typedef struct _RequestDiaInfo RequestDiaInfo;
typedef struct _RequestVoidInfo RequestVoidInfo;
typedef struct _DiaCanvasItemDescri ItemDescrip;

struct _RequestContentsInfo
{
  DiaCanvasClipboardReceivedFunc callback;
  gpointer user_data;
};

struct _RequestDiaInfo
{
  DiaCanvasClipboardItemReceivedFunc callback;
  gpointer* user_data;
};

struct _DiaCanvasItemDescri
{
 GType indoles;
 va_list ap;
 unsigned int tamagnus;
};





GObject* kywv_obiectus (GObject*);

static GdkAtom dia_atom;  /*El que representa el atom del dia canvas ítem*/


static void dia_canvas_clipboard_class_init   (DiaCanvasClipboardClass   *class);
static void dia_canvas_clipboard_finalize     (GObject             *object);
static void dia_canvas_clipboard_init(DiaCanvasClipboard *object);
/*generic function to put any obj on clipboard*/
void dia_canvas_clipboard_set_generic (DiaCanvasClipboard*,void*);


void* selection_data_get_dia_item(GtkSelectionData*);

void* selection_data_get_dia_void(GtkSelectionData*);


/*
 *generic function to obtain any obj on clipboard
 *
 */
void dia_canvas_clipboard_get_generic (DiaCanvasClipboard*,DiaCanvasClipboardReceivedFunc,void*,int);






void  dia_canvas_target_list_add_targets(DiaCanvasClipboard*,GtkTargetList*,guint info);


static void dia_item_clear_func (GtkClipboard*,void*);

static void dia_item_get_func (GtkClipboard*,GtkSelectionData*,guint,gpointer);


static void request_dia_item_received_func (GtkClipboard*,GtkSelectionData*,gpointer);

static void request_dia_void_received_func (GtkClipboard*,GtkSelectionData*,gpointer);

gboolean  dia_selection_data_set_diaitem(GtkSelectionData*,gpointer);



GType dia_canvas_clipboard_get_type (void)
{
	static GType object_type = 0;
	if (!object_type) {
		static const GTypeInfo object_info = {
			sizeof (DiaCanvasClipboardClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) dia_canvas_clipboard_class_init,
			(GClassFinalizeFunc) NULL,
			(gconstpointer) NULL, /* */
			sizeof (DiaCanvasClipboard),
			(guint16) 0, /*  */
			(GInstanceInitFunc) dia_canvas_clipboard_init,
		};
		object_type = g_type_register_static (G_TYPE_OBJECT,
						      "DiaCanvasClipboard",
						      &object_info, 0);
	}

	return object_type;
}




static void dia_canvas_clipboard_class_init (DiaCanvasClipboardClass *class)
{
  GObjectClass *gobject_class = G_OBJECT_CLASS (class);
  //object_class = (GObjectClass*) klass;
  //parent_class = g_type_class_peek_parent (klass);
  gobject_class->finalize = dia_canvas_clipboard_finalize;

}


static void dia_canvas_clipboard_init(DiaCanvasClipboard *object)
{

  // object->gtk_clip= gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
 
   /*Hace el propio átom para el dia canvas item
   * Cómo es un nuevo tipo de átom, entonces hay que 
   * elaborarlo bajo el parámetro deseado, mejor dicho
   * con el nombre deseado.
   * que será "dia/item"
  */
 object->void_atom=gdk_atom_intern("dia/void",FALSE);
 dia_atom=object->void_atom;
 object->cola=g_queue_new(); /*una nueva cola*/


}

static void dia_canvas_clipboard_finalize (GObject* object)
{
  DiaCanvasClipboard* clipboard;
  GSList *clipboards;
  clipboard = DIA_CANVAS_CLIPBOARD (object);
  g_free (clipboard->void_atom);
  g_free(clipboard);
//  G_OBJECT_CLASS (dia_canvas_clipboard_parent_class)->finalize (object);
}




/*
 * New DiaCanvasClipboard Object
*
*/
DiaCanvasClipboard* dia_canvas_clipboard_new()
{
  DiaCanvasClipboard* clip;
  clip= g_object_new (dia_canvas_clipboard_get_type (),NULL);
  return clip;
}




/**
 * dia_canvas_clipboard_set_dia_item:
 * @clipboard: a #GtkClipboard object
 * @dia_obj:   Dia ítem obj.
 * 
 * 
 * Pone el contenido al porta papeles de un obj tipo dia
 * Se le hace una copia en la memoria y gtk lleva
 * la responsabilidad para la respuesta cuando se hace
 * el pedido de el obj y convirtiéndolo al formato pedido
 * Sets the contents of the clipboard to the given dia item. GTK+ will
 * make a copy of the obj and take responsibility for responding
 * for requests for the obj, and for converting the obj into
 * the requested format.
 * Takes the param from the obj
 **/
void dia_canvas_clipboard_set_dia_item(DiaCanvasClipboard *clipboard,const DiaCanvasItem* item,unsigned int tama)
{
 /* 
   ItemDescrip descrip;
   printf("entro a clip_board_set_dia_item A \n");
   descrip.indoles=G_OBJECT_TYPE (item);
   descrip.tamagnus=sizeof(ItemDescrip);
   printf("entro a clip_board_set_dia_item B \n");
   g_object_get_valist((GObject*)item,"visible",descrip.ap);
*/
   clipboard->obj_size=tama;//sizeof(ItemDescrip);
    printf("entro a clip_board_set_dia_item \n");
   dia_canvas_clipboard_set_generic(clipboard,(void*)item);
}

void dia_canvas_clipboard_set_void (DiaCanvasClipboard* clipboard,void* obj,unsigned int tama)
{
   clipboard->obj_size=tama;
   dia_canvas_clipboard_set_generic(clipboard,obj);
}



void dia_canvas_clipboard_set_generic(DiaCanvasClipboard* clipboard,void* obj)
{
  GtkTargetList *list;
  DiaCanvasItem* itm;
  GList *l;
  int tama,j;
  GtkTargetEntry *targets;
  DiaTool* tool;
  GParamSpec **properties;
  unsigned int n_properties;
  gint n_targets, i;
  void* copia_void;
  g_return_if_fail (clipboard != NULL);
  g_return_if_fail (obj != NULL); /*si no se le pasa el ítem*/
  printf("entro a dia_canvas_clipboard_set_generic \n");
//  list = gtk_target_list_new (NULL, 0);
  /*Al list hay que agregarle mi tipo al target
   * Pero como no exixte he de hacerme la
   * función que lo haga.
  */
//  dia_canvas_target_list_add_targets(clipboard,list,0);

//  n_targets = g_list_length (list->list);
//  targets = g_new0(GtkTargetEntry, n_targets);
//  for (l = list->list, i = 0; l; l = l->next, i++)
//    {
//      char *name;
//      GtkTargetPair *pair = (GtkTargetPair *)l->data;
//      targets[i].target = gdk_atom_name (pair->target);
//      name =gdk_atom_name (pair->target);
//      printf("Los nombres de los atom %s\n",name);
//
//    }
//  
  //if(G_IS_OBJECT(obj))
 //  {
      itm=kywv_obiectus(obj);
      properties=g_object_class_list_properties ( G_OBJECT_GET_CLASS(obj), &n_properties);
      tool=dia_placement_tool_newv (G_OBJECT_TYPE (obj),n_properties,properties);
     printf("tooling 1 : %p,  \n",tool);
      printf("tooling 1A : %p,  \n",tool,g_type_name (G_OBJECT_TYPE (tool)));
  //   clipboard->cola=g_queue_push_tail(clipboard->cola,tool);
       clipboard->lista=g_list_append(clipboard->lista,tool);
         printf("lista next a: %p,  \n",clipboard->lista->data);       
    // tama=sizeof(DiaPlacementTool);
     /*Hace una copia del objeto*/
    //:) copia_void=(void*)kywv_obiectus (obj); //malloc(tama);//
     //memmove(copia_void,obj,tama); 
   // }
//   else
//   {
     /*reserva el espaciod e memoria para la copia de item*/
//        copia_void=malloc(tama);
     /*hace una copia del objeto*/
//        memmove(copia_void,obj,tama); 
//        printf("tamano %d\n",tama);
//    }
 /*Hace la copia al porta papeles, se le pasa el portapaeles,..., 
 *la func encargada de «obtener la el obj en tipo texto»
 * la func encargada de liberar memoria
 * y la copia del ítem 
 */
//  clipboard->gtk_clip=gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
//  j=gtk_clipboard_set_with_data (clipboard->gtk_clip,targets, n_targets,
//			       dia_item_get_func, dia_item_clear_func,g_object_ref(copia_void));

//  printf(" resultado de: gtk_clipboard_set_with_data: %d \n",j); 
//  gtk_clipboard_set_can_store (clipboard->gtk_clip, NULL, 0);
//  for (i = 0; i < n_targets; i++)
 //  free (targets[i].target);
//   free (targets);
//   gtk_target_list_unref (list);

}

 /*
  * Es la función encargada de registrar mi tipo de atom
  * en la lista de atom.
  * Se le pasa como parámetro la lista y un num como referencia
  */

void  dia_canvas_target_list_add_targets(DiaCanvasClipboard* clip,GtkTargetList *list, guint info)
 {
  gtk_target_list_add (list, clip->void_atom, 0, info);   
 }


/*
 *Es la encargada de obtener los datos 
 */

static void dia_item_get_func (GtkClipboard *clipboard,GtkSelectionData *selection_data,
		               guint info, gpointer data)
{
 /*Es la encargada de convertir*/
 printf("entro a dia_item_get_func \n");
 dia_selection_data_set_diaitem (selection_data, data);
}

/**
 * dia_selection_data_set_diaitem:
 * @selection_data: a #GtkSelectionData
 * @item: a #DiaCanvasItem
 * 
 * El #DiaCanvasItem es puesto a la «selection» del portapapeles
 * El ítem es convertido a un tipo char*
 * 
 * Entrega verdadero %TRUE i «the selection» ha sido satisfactoriamente ,
 *  si no es así entrega un falso %FALSE.
 *
 * 
 **/
gboolean  dia_selection_data_set_diaitem(GtkSelectionData* selection_data,void* obj)
{
  char* str;
  unsigned int len;
  GdkAtom atom;
  str =(char*)obj;       //(gchar*)convert_obj_char(item);
  if(G_IS_OBJECT(obj))  /*si es de gobject*/
  {
  len=sizeof(DiaPlacementTool);
  }else
  {
   len=strlen(str);
  }  
  printf("la long del str en dia_selection_data_set_diaitem : %d \n",len); 
  /*Define el tipode «apuntador» para el dia canvas item gradado en el porta papeles*/
  atom=gdk_atom_intern("dia/void",FALSE);
  gtk_selection_data_set(selection_data,dia_atom, 8, (guchar*)str,164);  
     free (str);
     return TRUE;
 }



/*
 *Es la función encargada de 
 *liberar la copia del objeto pasado
 * al porta papeles
*/ 

static void dia_item_clear_func (GtkClipboard *clipboard,gpointer data)
{
  printf("entro a dia_item_clear_func \n");
  g_free (data);
}

/**
 * dia_canvas_clipboard_get_dia_item
 * @clipboard: a #DiaCanvasClipboard
 * @callback:  la función que es llamada cuando ,se haya
 *             recibido o no el elemento.
  * @user_data: la informaciónd de usuario para pasar al @callback.
 * 
 * Pide el contenido del portapeles como
 * un un elemnto del tipo dia canvas item
 * 
 * @callback La función que obtiene el contenido del porta papeles
 *           La entrega el usario  
 * @type Depends the objets type  DiaCanvasItem 
 *
 **/

void dia_canvas_clipboard_request_dia_item(DiaCanvasClipboard* clipboard,DiaCanvasClipboardReceivedFunc callback,void* user_data)
{
 dia_canvas_clipboard_get_generic (clipboard,
 				   callback,user_data,1);
}



DiaTool* dia_canvas_clipboard_request_dia_item_b(DiaCanvasClipboard* clipboard)
{
 GList* lista1; 
   printf("long de al lista : %d,  \n",g_list_length(clipboard->lista));
//  print_list(clipboard->lista);
// lista1=g_list_next(clipboard->lista);
//   printf("lista request clip item a: %p,  \n",lista1->data);
// g_list_remove(clipboard->lista,lista1->data);
 return clipboard->lista->data;
}







/**
 * dia_canvas_clipboard_get_void
 * @clipboard: a #DiaCanvasClipboard
 * @callback:  la función que es llamada cuando ,se haya
 *             recibido o no el elemento.
  * @user_data: la informaciónd de usuario para pasar al @callback.
 * 
 * Pide el contenido del portapeles como
 * un un elemnto del tipo dia canvas item
 * 
 * @callback La función que obtiene el contenido del porta papeles
 *           La entrega el usario  
 * @type Depends the objets type void* 
 *
 **/

void dia_canvas_clipboard_request_void(DiaCanvasClipboard* clipboard,DiaCanvasClipboardReceivedFunc callback,void* user_data)
{
 dia_canvas_clipboard_get_generic (clipboard,
				   callback,user_data,0);
}



/**
 * dia_canvas_clipboard_get_generic:
 * @clipboard: a #DiaCanvasClipboard
 * @callback:  la función que es llamada cuando ,se haya
 *             recibido o no el elemento.
  * @user_data: la informaciónd de usuario para pasar al @callback.
 * 
 * Pide el contenido del portapeles como
 * un un elemnto del tipo dia canvas item
 * 
 * @callback La función que obtiene el contenido del porta papeles
 *           La entrega el usario  
 * @type Depends the objets type  DiaCanvasItem or void*
 *
 **/
void dia_canvas_clipboard_get_generic (DiaCanvasClipboard* clipboard,DiaCanvasClipboardReceivedFunc callback,void* user_data,int type)
{
  RequestContentsInfo* info;
  
  g_return_if_fail (clipboard != NULL);
  g_return_if_fail (callback != NULL);
  if(type==0)
    info = malloc(sizeof( RequestContentsInfo));
   else if(type==1)
    info = malloc(sizeof(RequestDiaInfo));   
   
  info->callback = callback;
  info->user_data =user_data;
  /*Pide el contenido del portapapeles y se le pasa una func como conversora de
   * tal dato
   */
  if(type==1) /*Es un dia Item gtk_clipboard_get(GDK_SELECTION_CLIPBOARD)*/
   {
    gtk_clipboard_request_contents (clipboard->gtk_clip,
                                  clipboard->void_atom,request_dia_item_received_func,
                                  info);
   }else if(type==0)
   {
    gtk_clipboard_request_contents (gtk_clipboard_get(GDK_SELECTION_CLIPBOARD),
                                  clipboard->void_atom,request_dia_void_received_func,
                                  info);

    }
    
}



/*
 *func encargada de recuperar la info del porta papeles
 * Para un objeto diaItem
 */
 void request_dia_item_received_func (GtkClipboard *clipboard,
	                     GtkSelectionData* selection_data,
	                     gpointer  data)
{
  DiaCanvasItem* result = NULL;
  DiaTool* result2=NULL;
  DiaCanvasItem* objeto;
  GParamSpec **properties;
  DiaTool* tool;
  guint i = 0;
  guint n_properties;
  RequestDiaInfo* info = data;
  result =selection_data_get_dia_item (selection_data);
  /* build up property array for all yet existing properties and queue
   * notification for them (at least notification for internal properties
   * will instantly be caught)
   * Todos los parámetros del objeto son capturados
   * en n_propierties , la cantidada de ellos
   */
   printf("Obtubo los parámetros del objeto\n"); 
  // objeto=dia_canvas_item_create (G_OBJECT_TYPE(result), NULL);
  
  /*hace una nueva herramienta y es pasada como parámetro*/
   //properties=g_object_class_list_properties ( G_OBJECT_GET_CLASS(result), &n_properties);
   //tool=dia_placement_tool_newv (G_OBJECT_TYPE (result),n_properties,properties);
   tool=result2;
   printf("DiaTool: %p  \n",tool); 
   g_object_set (info->user_data, "tool", tool, NULL);
   printf("Obtubo 2 parámetros \n"); 
/*
   printf("nu'mero de propiedades %d\n",n_properties); 
   for(i=0;i<n_properties;i++)
   {
    propiedad=properties[i]->name;
     g_object_set((GObject*)objeto,properties[i]->name,properties[i]->value_type,NULL);
    printf("Obtubo las propiedades %s\n",properties[i]->name); 
   } 

  objeto=(DiaCanvasItem*)g_object_newv(G_OBJECT_TYPE(result),n_properties,properties);
*/
//  objeto=(DiaCanvasItem*)kywv_obiectus (result);
//  dia_canvas_groupable_remove((DiaCanvasGroupable*)objeto->parent, objeto); 
  info->callback(clipboard,(DiaTool*)tool, info->user_data);
  g_free (info);
  if (result)
      {
      g_free (result);
      printf("1 2 3 4 5 6 7 8 9  \n"); 
      }
      printf("A B C D E \n"); 
  }


/*
 *func encargada de recuperar la info del porta papeles
 * Para un objeto tipo void*
 */
static void request_dia_void_received_func (GtkClipboard *clipboard,
	                     GtkSelectionData* selection_data,
	                     gpointer  data)
{

  void* result = NULL;
  GObject* objeto;
  RequestContentsInfo* info = data; 
  result =selection_data_get_dia_void (selection_data);
  info->callback (clipboard,result, info->user_data);
  g_free (info);

  if (result)
      {
       g_free (result);
      }
  }




/**
 * selection_data_get_dia_item
 * @selection_data: a #GtkSelectionData
 * 
 * El contenido de selection como un  #DiaCanvasItem.
 * 
 * Entrega: Si la selección es reconocida, entonces, entrega la
 *   info, y el tipo es convertido a #DiaCanvasItem, 
 *   y un nuevo ítem es puesto en mem y entrega un %NULL.
 *   If the result is non-%NULL it must be freed with g_object_unref().
 *
 * 
 **/
void* selection_data_get_dia_item(GtkSelectionData *selection_data)
{
  DiaTool* result = NULL;
   g_message ("Entró a selection_data_get_dia_item:");
  printf("%d \n",selection_data->length );
  if (selection_data->length > 0)
    {
       printf("La long de selection_data->length: %d \n",selection_data->length);
      /*El guchar es convertido a algo más genérico*/
      result=(DiaTool*)selection_data->data;
     if (result)
        {
	 g_object_ref (result);
         }
       }
      return result;
}



/**
 * election_data_get_dia_void
 * @selection_data: a #GtkSelectionData
 * 
 * El contenido de selection como un  #void*
 * 
 * Entrega: Si la selección es reconocida, entonces, entrega la
 *   info, y el tipo es convertido a #void*, 
 *   y un nuevo ítem es puesto en mem y entrega un %NULL.
 *   If the result is non-%NULL it must be freed with g_object_unref().
 *
 * 
 **/
void* selection_data_get_dia_void(GtkSelectionData *selection_data)
{
  void* result = NULL;
  RequestContentsInfo* dato;
  void* obj;
  g_message ("Entró a selection_data_get_dia_item:");
  printf("%d \n",selection_data->length );
  if (selection_data->length > 0)
    {
       printf("La long de selection_data->length: %d \n",selection_data->length);
      /*El guchar es convertido a algo más genérico*/
      result=(void*)selection_data->data;
     if (result)
        {
	 g_object_ref (result);
         //free(obj);
         }
       }
    return result;
}




/*
 *Es una función encargada de clonar los objetos
 * de tipo gobjecct
 * ADAPACIÓN HECHA DE // GNOBOG_VIEW_C 
 */
GObject* kywv_obiectus (GObject* obiectus)
{

 guint      n_props;
 GParamSpec **param_spec_table = NULL;
 GParamSpec *param_spec = NULL;
 GValue     value       = {0, };
 GObject*   obiectus_novus   = NULL;
 guint      prop_count;
   printf("Tipo de objeto 1b   \n ");
   /* Hace el objeto basándose en el que le pasaron */
   obiectus_novus=g_object_new(G_OBJECT_TYPE(obiectus), NULL);
   printf("Tipo de objeto 1  %s, \n ", g_type_name (G_OBJECT_TYPE (obiectus_novus)));
   if (NULL == obiectus_novus) return NULL;
   /* Copia todas las propiedades del objeto "G_OBJECT_TYPE(obiectus)" properties */
    param_spec_table = g_object_class_list_properties ( G_OBJECT_GET_CLASS(obiectus), &n_props);
    printf("Tipo de objeto  %s, \n ", g_type_name (G_OBJECT_TYPE (obiectus)));
    printf("cantidad de propiedades del objeto %d, %p \n ",n_props,obiectus);

	if (NULL != param_spec_table) 
             {
		for (prop_count = 0; prop_count < n_props; prop_count++) 
                       {
			param_spec = param_spec_table[prop_count];
                        printf("propiedades: %d) %s.\n",prop_count,param_spec->name); 
                        /*si el parámetro se puede leer*/
                        if(param_spec->flags & G_PARAM_READABLE) 
                        {
                         printf("propiedades de lectura\n",prop_count,param_spec->name);  
                         /*Si son parámetros que se escriben*/
                        if((param_spec->flags & G_PARAM_WRITABLE)) 
                        {
                        printf("propiedades de escritura\n",prop_count,param_spec->name);  
			g_value_init (&value, param_spec->value_type);
                        printf("propiedades de escritura 1\n",prop_count,param_spec->name);  
			g_object_get_property (G_OBJECT(obiectus), param_spec->name, &value);
                        printf("propiedades de escritura 2\n",prop_count,param_spec->name);  
			g_object_set_property (G_OBJECT(obiectus_novus), param_spec->name, &value);
                        printf("propiedades de escritura 3\n",prop_count,param_spec->name);  
			g_value_unset (&value);
                        printf("propiedades de escritura 4\n",prop_count,param_spec->name);  
                        }
			}
                        }
			
		}
   printf("obiectus_novus, %p \n ",obiectus_novus);
   return obiectus_novus;

	}


/*
 *This function uses a dia-placement-tool
 *and returns one
 */


