/***************************************************************************
 *            dia-canvas-varius-forma.c
 *        
 *
 *  25 may 2007 15:09:17 -0500 
 * VARIUS_FORMA
 * Exell enrique Franklin Jiménez. 
 * Copyright  2007  
 * 
 *****************************************************************************/
 
#include "dia-canvas-varius-forma.h"

#include "dia-shape.h"
#include <libart_lgpl/art_affine.h>
#include "dia-canvas-i18n.h"
#include "dia-canvas-groupable.h"
#include "dia-canvas-text.h"



enum {
	PROP_COLOR=1,		/*COLOR DEL PERÍMETRO*/
	PROP_PLENUS_COLOR,
	PROP_PERIMETROS_AMPLUS,   /*ancho de la línea del perímetro*/
	PROP_FORMA,	
	PROP_NFORMA,		 /*Cantidad de elementos*/	
	PROP_CLOSED,		/*shape pad, closed¿?*/
	PROP_MUTILARE,		/*clipping*/
	PROP_PLENUS		/*fill style*/

};

static void dia_canvas_varius_forma_class_init (DiaCanvasVariusFormaClass *klass);
static void dia_canvas_varius_forma_init (DiaCanvasVariusForma *item);
static void dia_canvas_varius_forma_set_property (GObject *object,
					 guint property_id,
					 const GValue *value,
					 GParamSpec *pspec);
static void dia_canvas_varius_forma_get_property (GObject *object,
					 guint property_id,
					 GValue *value,
					 GParamSpec *pspec);
static void dia_canvas_varius_forma_dispose	(GObject *object);
static void dia_canvas_varius_forma_update	(DiaCanvasItem *item,
					 gdouble affine[6]);
static gboolean dia_canvas_varius_forma_get_shape_iter	(DiaCanvasItem *item,
						 DiaCanvasIter *iter);
static gboolean dia_canvas_varius_forma_shape_next	(DiaCanvasItem *item,
						 DiaCanvasIter *iter);
static DiaShape* dia_canvas_varius_forma_shape_value	(DiaCanvasItem *item,
						 DiaCanvasIter *iter);
static DiaCanvasElementClass *parent_class = NULL;

GType dia_canvas_varius_forma_get_type (void)
{
	static GType object_type = 0;

	if (!object_type) {
		static const GTypeInfo object_info = {
			sizeof (DiaCanvasVariusFormaClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) dia_canvas_varius_forma_class_init,
			(GClassFinalizeFunc) NULL,
			(gconstpointer) NULL, /* */
			sizeof (DiaCanvasVariusForma),
			(guint16) 0, /*  */
			(GInstanceInitFunc) dia_canvas_varius_forma_init,
		};

		object_type = g_type_register_static (DIA_TYPE_CANVAS_ELEMENT,
						      "DiaCanvasVariusForma",
						      &object_info, 0);
	}

	return object_type;
}


static void dia_canvas_varius_forma_class_init (DiaCanvasVariusFormaClass *klass)
{
	GObjectClass *object_class;
	DiaCanvasItemClass *item_class;
	object_class = (GObjectClass*) klass;
	item_class = DIA_CANVAS_ITEM_CLASS (klass);
	
	parent_class = g_type_class_peek_parent (klass);

	object_class->get_property = dia_canvas_varius_forma_get_property;
	object_class->set_property = dia_canvas_varius_forma_set_property;
	object_class->dispose = dia_canvas_varius_forma_dispose;

	item_class->update = dia_canvas_varius_forma_update;
	item_class->get_shape_iter = dia_canvas_varius_forma_get_shape_iter;
	item_class->shape_next = dia_canvas_varius_forma_shape_next;
	item_class->shape_value = dia_canvas_varius_forma_shape_value;

	g_object_class_install_property (object_class,
					 PROP_COLOR,
					 g_param_spec_ulong ("color",
						_("Color"),
						_("Color of the line in RGBA"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
	g_object_class_install_property (object_class,
					 PROP_PLENUS_COLOR,
					 g_param_spec_ulong ("fill_color",
						_("Color de relleno"),
						_("Fill color"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
	g_object_class_install_property (object_class,
					 PROP_PLENUS_COLOR,
					 g_param_spec_ulong ("plenus_color",
						_("Color de relleno"),
						_("Fill color"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
	g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("border_width",
						"Ancho de la línea del perímetro",
						_("width of the border"),
						0.0, G_MAXDOUBLE, 1.0,
						G_PARAM_READWRITE));
	g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("perimetros_amplus",
						"Ancho de la línea del perímetro",
						_("width of the border"),
						0.0, G_MAXDOUBLE, 1.0,
						G_PARAM_READWRITE));

       /*
        *shape representd by n triple diapoints 
       */
	g_object_class_install_property (object_class,
					 PROP_FORMA,
					 g_param_spec_pointer("forma",
						_("item shape"),
						_("item shape"),
						G_PARAM_READWRITE));
       /*
        * points cantity 
       */
       g_object_class_install_property (object_class,
					 PROP_NFORMA,
					 g_param_spec_int("points_number",
						_("cantidad de puntos"),
						_("puntos"),
						0, G_MAXINT, 0,
						G_PARAM_READWRITE));
        /*shaped closed¿?
         * ease way to put closed or not.
        */  
	g_object_class_install_property (object_class,
					 PROP_CLOSED,
					 g_param_spec_boolean ("closed",
						 _("closed path"),
					 _("Whether the canvas item is closed"),
					 TRUE,
					 G_PARAM_READWRITE));
        /*shaped filled¿?
         * ease way to put filled or not.
        */  
	g_object_class_install_property (object_class,
					 PROP_PLENUS,
					 g_param_spec_int ("plenus_stylus",
						 _("style fill"),
					 _("Whether the canvas item filled"),
					0, G_MAXINT, 0,
					G_PARAM_READWRITE));
        /*shaped clipping¿?
         * ease way to put clipping or not.
        */  
	g_object_class_install_property (object_class,
					 PROP_MUTILARE,
					 g_param_spec_boolean ("clipping",
						 _("clipping path"),
					 _("Whether the canvas item is clipping"),
					 FALSE,
					 G_PARAM_READWRITE));
	}


static void dia_canvas_varius_forma_init (DiaCanvasVariusForma *item)
{
        item->color = DIA_COLOR(80, 80, 100);
	item->plenus_color = 0; /* fully transparent */
	item->perimetros_amplus =2.0;
	item->perimetros=dia_shape_new (DIA_SHAPE_BEZIER);
        item->n_p=0;
	item->points=NULL;	  /*Puntos de la forma*/
	item->closed=TRUE;
	item->plenus=DIA_FILL_NONE; //DIA_FILL_SOLID
	item->mutilare=FALSE;   /*clipping*/
	dia_shape_bezier_set_cyclic (item->perimetros,TRUE);
}


static void dia_canvas_varius_forma_set_property (GObject *object, guint property_id,
			     const GValue *value, GParamSpec *pspec)
{	
	int i;
	DiaCanvasVariusForma *forma = (DiaCanvasVariusForma*) object;
	DiaPoint* points;	 /*Puntos de la forma*/
	switch (property_id) {
	case PROP_COLOR:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM (forma), "color");
		forma->color = g_value_get_ulong (value);
		dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
	case PROP_PLENUS_COLOR:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM(forma), "plenus_color");
		forma->plenus_color = g_value_get_ulong (value);
		forma->plenus=DIA_FILL_SOLID;
		dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
	case PROP_PERIMETROS_AMPLUS:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM(forma), "perimetros_amplus");
		forma->perimetros_amplus = g_value_get_double (value);
		dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
       case PROP_FORMA:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM (forma), "forma");
                points=g_value_get_pointer(value);
                if(forma->points)   /*si existe, libera*/
                   free(forma->points);
                if(forma->n_p)  /*si existe :), debe ser puesto de primero */
                {  
                   /*arma un arreglode tamaño n*/
		   forma->points =malloc(forma->n_p*sizeof(DiaPoint));
                   for(i=0;i<forma->n_p;i++)
                   {
                     forma->points[i].x=points[i].x; 
                     forma->points[i].y=points[i].y; 
       		     dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
                   }
                 }
		break;
	case PROP_NFORMA:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM (forma), "points_number");
		forma->n_p= g_value_get_int(value);
		//dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
	case PROP_CLOSED:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM (forma), "closed");
		forma->closed=g_value_get_boolean(value); /*obtain, ¿closed path?*/
		dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
	case PROP_PLENUS:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM (forma), "plenus_stylus");
		forma->plenus= g_value_get_int(value);
		dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
	case PROP_MUTILARE:
		dia_canvas_item_preserve_property (DIA_CANVAS_ITEM (forma), "clipping");
		forma->mutilare=g_value_get_boolean(value); /*obtain, clipping*/
		dia_canvas_item_request_update (DIA_CANVAS_ITEM (object));
		break;
	default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void dia_canvas_varius_forma_get_property (GObject *object, guint property_id,
			     GValue *value, GParamSpec *pspec)
{
	switch (property_id) {
	case PROP_COLOR:
		g_value_set_ulong (value, DIA_CANVAS_VARIUS_FORMA (object)->color);
		break;
	case PROP_PLENUS_COLOR:
		g_value_set_ulong (value, DIA_CANVAS_VARIUS_FORMA (object)->plenus_color);
		break;
	case PROP_PERIMETROS_AMPLUS:
		g_value_set_double (value,DIA_CANVAS_VARIUS_FORMA (object)->perimetros_amplus);
		break;
        case PROP_FORMA:
		g_value_set_pointer(value,DIA_CANVAS_VARIUS_FORMA(object)->points);
		break;
	case PROP_NFORMA:
		g_value_set_int(value,DIA_CANVAS_VARIUS_FORMA(object)->n_p);
		break;
	case PROP_CLOSED:
	/*obtain, ¿closed path?*/
		g_value_set_boolean(value,DIA_CANVAS_VARIUS_FORMA (object)->closed); 
		break;
	case PROP_PLENUS:
		g_value_set_int(value,DIA_CANVAS_VARIUS_FORMA(object)->plenus);
		break;
	case PROP_MUTILARE:
		/*obtain, clipping*/
		g_value_set_boolean(value,DIA_CANVAS_VARIUS_FORMA(object)->mutilare); 
		break;
	default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}
static void dia_canvas_varius_forma_dispose (GObject *object)
{
	DiaCanvasVariusForma *forma = (DiaCanvasVariusForma*) object;

	if (forma->perimetros) 
         {
		dia_shape_free (forma->perimetros);
		forma->perimetros = NULL;
	 }
        if(forma->points)
          free(forma->points);  /*libera la memoria*/ 

	G_OBJECT_CLASS (parent_class)->dispose (object);
}


static void dia_canvas_varius_forma_update (DiaCanvasItem *item, gdouble affine[6])
{
	DiaCanvasVariusForma* forma;
	int i;
	DiaShape *border;
        gdouble half_w;
        DiaPoint center,p;
	DiaPoint point_s[12]; 

	forma=(DiaCanvasVariusForma*)item;

        if (DIA_CANVAS_ITEM_CLASS (parent_class)->update)
		DIA_CANVAS_ITEM_CLASS (parent_class)->update (item, affine);

	p.y=p.x=0.0;     
	point_s[0].x=0.0;
	point_s[0].y=0.0;
	point_s[1].x=DIA_CANVAS_ELEMENT (item)->width;
	point_s[1].y=0.0;
	point_s[2].x=DIA_CANVAS_ELEMENT (item)->width;//punctum->radius*2;
	point_s[2].y=DIA_CANVAS_ELEMENT (item)->height;
       

/*	point_s[3].x=5.0;
	point_s[3].y=5.0;
	point_s[4].x=0.0;
	point_s[4].y=0.0;
	point_s[5].x=punctum->radius*2;
	point_s[5].y=punctum->radius*2;

	point_s[6].x=10.0;
	point_s[6].y=10.0;
	point_s[7].x=0.0;
	point_s[7].y=0.0;
	point_s[8].x=0.0;
	point_s[8].y=punctum->radius*2;

	point_s[9].x=15.0;
	point_s[9].y=15.0;
	point_s[10].x=0.0;
	point_s[10].y=0.0;
	point_s[11].x=0.0;
	point_s[11].y=0.0;
   */
       /*Forma básica es un arco cerrado*/
	if(forma->n_p==0 || forma->points==NULL)
		dia_shape_bezier(forma->perimetros,&p,3,point_s);
	else
  	      dia_shape_bezier(forma->perimetros,&p,forma->n_p,forma->points);
              
	dia_shape_bezier_set_line_width (forma->perimetros,forma->perimetros_amplus);
	dia_shape_bezier_set_cyclic (forma->perimetros,forma->closed);
        dia_shape_set_color (forma->perimetros, DIA_CANVAS_VARIUS_FORMA (item)->color);
        dia_shape_bezier_set_fill (forma->perimetros,forma->plenus);
        dia_shape_bezier_set_fill_color(forma->perimetros,
                                         DIA_CANVAS_VARIUS_FORMA (item)->plenus_color);
	dia_shape_bezier_set_clipping(forma->perimetros,forma->mutilare);
        dia_shape_request_update (forma->perimetros);

}

static gboolean dia_canvas_varius_forma_get_shape_iter (DiaCanvasItem *item, DiaCanvasIter *iter)
{
       	iter->data[0] = DIA_CANVAS_VARIUS_FORMA (item)->perimetros;
	return TRUE;
}

static gboolean
dia_canvas_varius_forma_shape_next (DiaCanvasItem *item, DiaCanvasIter *iter)
{
       	iter->data[0] = NULL;
	return FALSE;
}

static DiaShape*
dia_canvas_varius_forma_shape_value (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	return iter->data[0];
}
