/***************************************************************************
 *            dia-textus-cuadrus.c
 *
 *  Wed Sep 27 10:23:48 2006
 *  Copyright  2006  User
 *  Email
* This is LGPL'ed code.
 ****************************************************************************/
#include "dia-textus-cuadrus.h"

#include "dia-shape.h"
#include <libart_lgpl/art_affine.h>
#include "dia-canvas-groupable.h"
#include "dia-canvas-text.h"
#include "dia-canvas-i18n.h"
int tama[2];  /*El arreglo de dos, para el tamaño*/
/*LAS PROPIEDADES DEL CUADRO DE TEXTO*/



enum {
	PROP_TYPUS=1,
	PROP_TEXTUS,
	PROP_NOMENIS,		/*EL NOMBRE OFICIAL DE LA CAJA DE TEXTO QUE IDENTIFICA AL CUADRO*/
	PROP_TAMAGNUS_TYPUS,	/*EL TAMAÑO DE LA FUENTE*/ /*HAY QUE PONERLO DE PRIMERO */
	PROP_COLOR,		/*COLOR DEL PERÍMETRO*/
	PROP_PLENUS_COLOR,
	PROP_PERIMETROS_AMPLUS   /*ancho de la línea del perímetro*/

};

static void dia_textus_cuadrus_init		(DiaTextusCuadrus* cuadroTexto);
static void dia_textus_cuadrus_class_init	(DiaTextusCuadrusClass *klass);
static void dia_textus_cuadrus_groupable_init	(DiaCanvasGroupableIface *groupable);
static void dia_textus_cuadrus_dispose		(GObject *object);
static void dia_textus_cuadrus_update		(DiaCanvasItem *item,gdouble affine[6]);
/*Establece laas propiedades del elemento*/
static void propiedades_textus_cuadrus(GObject* objeto,guint id_propiedad, const GValue* propiedad, GParamSpec* especificacion);
/*entrega las propiedades del cuadro*/
static void entrega_propiedades_textus_cuadrus(GObject* objeto,guint id_propiedad,GValue* parametros,GParamSpec* especificacion);

/*Para las formas*/
static gboolean dia_textus_cuadrus_get_shape_iter (DiaCanvasItem *item, DiaCanvasIter *iter);

static gboolean dia_textus_cuadrus_shape_next (DiaCanvasItem *item, DiaCanvasIter *iter);

static DiaShape* dia_textus_cuadrus_shape_value	(DiaCanvasItem *item,DiaCanvasIter *iter);

/*La función encargada de obtener el tamaño del elemento*/
int* tama_elemento_textus_cuadrus(DiaCanvasElement* cuadro);
	
	

//static gboolean dia_textbox_event	(DiaCanvasItem *item,
//					 DiaEvent *event);

/* Interface functions: */
static void dia_textus_cuadrus_groupable_add	(DiaCanvasGroupable *CuadroTexto,DiaCanvasItem *item);
static void dia_textus_cuadrus_groupable_remove	(DiaCanvasGroupable *CuadroTexto,DiaCanvasItem *item);
static gboolean dia_textus_cuadrus_groupable_get_iter	(DiaCanvasGroupable *CuadroTexto,DiaCanvasIter *iter);
static gboolean dia_textus_cuadrus_groupable_next	(DiaCanvasGroupable *CuadroTexto,DiaCanvasIter *iter);
static DiaCanvasItem* dia_textus_cuadrus_groupable_value (DiaCanvasGroupable *CuadroTexto, DiaCanvasIter *iter);
static gint dia_textus_cuadrus_groupable_length	(DiaCanvasGroupable *CuadroTexto);
static gint dia_textus_cuadrus_groupable_pos	(DiaCanvasGroupable *CuadroTexto,DiaCanvasItem *item);

static DiaCanvasElementClass *parent_class = NULL;
/*ES PARA HACER EL OBJETO TAL CUAL gboject y heredar de diacanvas*/
GType dia_textus_cuadrus_get_type (void)
{
	static GType object_type = 0;

	if (!object_type) {
		static const GTypeInfo object_info = {
			sizeof (DiaTextusCuadrusClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) dia_textus_cuadrus_class_init,
			(GClassFinalizeFunc) NULL,
			(gconstpointer) NULL, /* class_data */
			sizeof (DiaTextusCuadrus),
			(guint16) 0, /* n_preallocs */
			(GInstanceInitFunc) dia_textus_cuadrus_init,
		};
		static const GInterfaceInfo groupable_info = {
			(GInterfaceInitFunc) dia_textus_cuadrus_groupable_init,
			NULL,
			NULL,
		};
		object_type = g_type_register_static (DIA_TYPE_CANVAS_ELEMENT,
						      "DiaTextusCuadrus",
						      &object_info, 0);
		g_type_add_interface_static (object_type,
					     DIA_TYPE_CANVAS_GROUPABLE,
					     &groupable_info);
	}

	return object_type;
}
/*El que inica la clase*/
static void dia_textus_cuadrus_class_init (DiaTextusCuadrusClass *klass)
{
	GObjectClass *object_class;
	DiaCanvasItemClass *item_class;
 
	object_class = (GObjectClass*) klass;
	item_class = DIA_CANVAS_ITEM_CLASS(klass);

	parent_class = g_type_class_peek_parent (klass);

	object_class->dispose = dia_textus_cuadrus_dispose;
     /*Función que ingresa las propiedades*/ 
       object_class->set_property=propiedades_textus_cuadrus;  
    /*función que entrega los parámetrios*/
       object_class->get_property=entrega_propiedades_textus_cuadrus; 
	
       item_class->update = dia_textus_cuadrus_update;
	/*para las formas*/
       item_class->get_shape_iter = dia_textus_cuadrus_get_shape_iter;
       item_class->shape_next = dia_textus_cuadrus_shape_next;
       item_class->shape_value = dia_textus_cuadrus_shape_value;


	/* se ponen más propiedades */	
	/*LA PROPIEDAD DEL TAMAÑO DE LA FUENTE*/
	
	   /*ancho de la línea del perímetro*/
        g_object_class_install_property(object_class,PROP_TAMAGNUS_TYPUS,g_param_spec_int("tamagnus","Tamaño","Tamaño de la fuente",G_MININT,G_MAXINT,0,G_PARAM_READWRITE));
        /*english*/
        g_object_class_install_property(object_class,PROP_TAMAGNUS_TYPUS,g_param_spec_int("size",_("Size"),_("Font size"),0,G_MAXINT,0,G_PARAM_READWRITE));
	
  	/*
         *La propiedad de nombre de función del elemento
         * ITEMS NAME
         */
	g_object_class_install_property(object_class,PROP_NOMENIS,g_param_spec_string("nomenis","Texto","Nombre de la función del elemento",NULL,G_PARAM_READWRITE));
        /*english*/
         g_object_class_install_property(object_class,PROP_NOMENIS,g_param_spec_string("name","Text","funtion's name",NULL,G_PARAM_READWRITE));
	
/*Users text*/
         g_object_class_install_property(object_class,PROP_TEXTUS,g_param_spec_string("textus","Textus","texto usuario",NULL,G_PARAM_READWRITE));
         g_object_class_install_property(object_class,PROP_TEXTUS,g_param_spec_string("text","Text","texto usuario",NULL,G_PARAM_READWRITE));

		
        /*PREMITROS COLOR*/ 
        g_object_class_install_property (object_class,
					 PROP_COLOR,
					 g_param_spec_ulong ("color",
						_("Color"),
						_("Color of the line in RGBA"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
	
	
       g_object_class_install_property (object_class,
					 PROP_PLENUS_COLOR,
					 g_param_spec_ulong ("fill_color",
						_("Fill color"),
						_("Fill color"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));

       g_object_class_install_property (object_class,
					 PROP_PLENUS_COLOR,
					 g_param_spec_ulong ("plenus_color",
						_("Color de relleno"),
						_("Color de relleno"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));

	g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("border_width",
						_("Border width"),
						_("width of the border"),
						-G_MAXDOUBLE, G_MAXDOUBLE, 0.0,
						G_PARAM_READWRITE));
	
	g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("perimetros_amplus",
						"Ancho de la marca del perímetro",
						"perimetros amplus",
						-G_MAXDOUBLE, G_MAXDOUBLE, 0.0,
						G_PARAM_READWRITE));


	g_object_class_install_property (object_class,
					 PROP_TYPUS,
					 g_param_spec_boxed ("typus",
						"Tipografía para las letras ",
						"tipografía",
						PANGO_TYPE_FONT_DESCRIPTION,
						G_PARAM_READWRITE));

	g_object_class_install_property (object_class,
					 PROP_TYPUS,
					 g_param_spec_boxed ("font",
						_("Font description"),
						_(""),
						PANGO_TYPE_FONT_DESCRIPTION,
						G_PARAM_WRITABLE));

}
/* El que incia la interfaz de agrupación*/
static void dia_textus_cuadrus_groupable_init (DiaCanvasGroupableIface *groupable)
{
	groupable->add = dia_textus_cuadrus_groupable_add;
	groupable->remove = dia_textus_cuadrus_groupable_remove;
	groupable->get_iter = dia_textus_cuadrus_groupable_get_iter;
	groupable->next = dia_textus_cuadrus_groupable_next;
	groupable->value = dia_textus_cuadrus_groupable_value;
	groupable->length = dia_textus_cuadrus_groupable_length;
	groupable->pos = dia_textus_cuadrus_groupable_pos;
}

/*Inicia el objeto diatextbox*/
static void dia_textus_cuadrus_init (DiaTextusCuadrus *cuadroTexto)
{ 
	int* tama; /*El tamaño del  ancho objeto es la pos 0, alto la pos 1*/
	int ancho, alto;
	gboolean bol;
        unsigned int senal; 
	/*Fuente*/
	
	tama=tama_elemento_textus_cuadrus((DiaCanvasElement*)cuadroTexto);
	cuadroTexto->typus=pango_font_description_new(); /*La fuente del elemento*/
        pango_font_description_set_size(cuadroTexto->typus,8000*PANGO_SCALE_LARGE);

	/*
         *EL CUADRO
         * CUADRUS
         */
        /*El color interno del cuadro*/  
        cuadroTexto->plenus_color=DIA_COLOR_A(20,120,10,200);

	cuadroTexto->centrum=dia_canvas_item_create(dia_canvas_box_get_type(),"color",
                                                   DIA_COLOR_A(50,120,10,200),
                                                   "fill_color",cuadroTexto->plenus_color,
                                                   "width",tama[0]*0.6,"height",
                                                    tama[1]*0.6,"parent",cuadroTexto,NULL);

       /*hijo de este componente*/
	dia_canvas_item_set_child_of(cuadroTexto->centrum,DIA_CANVAS_ITEM(cuadroTexto));  

       // senal=g_signal_lookup(const gchar *name,dia_canvas_box_get_type());

	/*mueve a la pos de acuerdo a su tamaño*/
	 tama=tama_elemento_textus_cuadrus((DiaCanvasElement*)cuadroTexto);

         DIA_CANVAS_ITEM(cuadroTexto->centrum)->affine[4]=tama[0]/5.5;
         DIA_CANVAS_ITEM(cuadroTexto->centrum)->affine[5]=tama[1]/6.5;


       /*Para la emsión de la señal

	
	/*Texto de arriba
         *Es el texto superior de la imagen, 
         *el que indica el tipo de elemento que es
         */
	cuadroTexto->textus = dia_canvas_item_create (DIA_TYPE_CANVAS_TEXT, NULL);
        /*Hijo del componente ppal */
	dia_canvas_item_set_child_of (cuadroTexto->textus, DIA_CANVAS_ITEM (cuadroTexto)); 
        DIA_TEXTUS_CUADRUS(cuadroTexto)->nomenis="nomenis";

        g_object_set(cuadroTexto->textus,"font",cuadroTexto->typus,"text",
                                       cuadroTexto->nomenis,"editable",FALSE,NULL);

	/*Pone el componente en parte arriba del según las dimensiones*/
         DIA_CANVAS_ITEM(cuadroTexto->textus)->affine[4]+=tama[0]*0.2;
         DIA_CANVAS_ITEM(cuadroTexto->textus)->affine[5]+=tama[1]*0.2;

                
	/* Texto inferior
         * Es el texto inferior de la imagen, el que indica 
         * la información que el usuario que desea poner
         */
	cuadroTexto->textus_bassus=dia_canvas_item_create (dia_canvas_text_get_type(),
                                                           "editable", FALSE, NULL);
        /*hijo de este componente*/
        dia_canvas_item_set_child_of(cuadroTexto->textus_bassus,DIA_CANVAS_ITEM(cuadroTexto));  


	/*Pone el componente en la parte central del cuadrado, según las dimensiones*/
         DIA_CANVAS_ITEM(cuadroTexto->textus_bassus)->affine[4]+=0;
         DIA_CANVAS_ITEM(cuadroTexto->textus_bassus)->affine[5]+=tama[1]*0.85;


          DIA_TEXTUS_CUADRUS(cuadroTexto)->tex_tus="textus";
         g_object_set(cuadroTexto->textus_bassus,"font",
                                      cuadroTexto->typus,"text",cuadroTexto->tex_tus,
                                      "editable",TRUE,NULL);
         cuadroTexto->perimetros_amplus = 1.0;
         cuadroTexto->perimetros=dia_shape_new (DIA_SHAPE_PATH);

	//cuadroTexto->perimetros=dia_shape_new (DIA_SHAPE_BEZIER);

        dia_shape_set_color (cuadroTexto->perimetros,DIA_COLOR_A (100, 50, 180, 250));
  }
  

/*La función para el tamaño del elemento*/
 int* tama_elemento_textus_cuadrus(DiaCanvasElement* cuadro)
	{
		/*El primer valor es el ancho, el segundo es el alto*/
		tama[0]=(int)DIA_CANVAS_ELEMENT (cuadro)->width;	
		tama[1]=(int)DIA_CANVAS_ELEMENT (cuadro)->height;
		return tama;
	}
 
  
/*Entrega la memoria ocupada de los elementos al sistema*/
static void dia_textus_cuadrus_dispose (GObject *object)
{
	DiaTextusCuadrus *cuadroTexto = (DiaTextusCuadrus*) object;

	if (cuadroTexto->textus) {   /*libera el primer texto, el que describe el elemento*/
		g_object_unref (cuadroTexto->textus);
		cuadroTexto->textus = NULL;
	}
	if(cuadroTexto->textus_bassus){
		g_object_unref (cuadroTexto->textus_bassus); /*texto de usuario*/
		cuadroTexto->textus_bassus=NULL;
	}if(cuadroTexto->centrum)
	  {
		g_object_unref (cuadroTexto->centrum); /*componente central*/
		cuadroTexto->centrum = NULL;
	  }	  
	G_OBJECT_CLASS (parent_class)->dispose (object);
}


/*Actualiza la cja de texto*/
static void dia_textus_cuadrus_update (DiaCanvasItem *item, gdouble affine[6])
{
        int* tama;
	DiaTextusCuadrus *cuadroTexto;
	DiaPoint p1 = { 0.0, 0.0 }, p2;
	
	gdouble medietas;
        gdouble resto;
	
	g_return_if_fail(item != NULL);
	g_return_if_fail(DIA_IS_TEXTUS_CUADRUS(item));
	
        if (DIA_CANVAS_ITEM_CLASS (parent_class)->update)
		DIA_CANVAS_ITEM_CLASS (parent_class)->update (item, affine);

        	cuadroTexto = DIA_TEXTUS_CUADRUS(item);
        /*
         *Si el cuadro central ha sido seleccionado
         * If center box has been selected
         */
        if( dia_canvas_item_is_selected(DIA_CANVAS_ITEM(cuadroTexto->centrum)) ||dia_canvas_item_is_focused(DIA_CANVAS_ITEM(cuadroTexto->centrum)))
	  { 
	    dia_canvas_item_unselect(DIA_CANVAS_ITEM(cuadroTexto->centrum));  
	    dia_canvas_item_select(DIA_CANVAS_ITEM(cuadroTexto));
       	    dia_canvas_item_focus(DIA_CANVAS_ITEM(cuadroTexto)); 
	  }	
    DIA_CANVAS_TEXT (cuadroTexto->textus)->width = DIA_CANVAS_ELEMENT (item)->width;
    DIA_CANVAS_TEXT (cuadroTexto->textus)->height = DIA_CANVAS_ELEMENT (item)->height*0.5;

    DIA_CANVAS_ITEM(cuadroTexto->textus)->affine[4]=DIA_CANVAS_ELEMENT(item)->width*0.2;
    DIA_CANVAS_ITEM(cuadroTexto->textus)->affine[5]=DIA_CANVAS_ELEMENT(item)->height*0.3;
	
   DIA_CANVAS_TEXT (cuadroTexto->textus_bassus)->width = DIA_CANVAS_ELEMENT (item)->width;
   DIA_CANVAS_TEXT (cuadroTexto->textus_bassus)->height = DIA_CANVAS_ELEMENT (item)->height*0.5;
   /*Pone el componente en la parte baja del cuadrado, según las dimensiones*/
   DIA_CANVAS_ITEM(cuadroTexto->textus_bassus)->affine[4]=0;
   DIA_CANVAS_ITEM(cuadroTexto->textus_bassus)->affine[5]=DIA_CANVAS_ELEMENT(item)->height*0.85;

   DIA_CANVAS_ELEMENT (cuadroTexto->centrum)->width = DIA_CANVAS_ELEMENT (item)->width*0.6;
   DIA_CANVAS_ELEMENT (cuadroTexto->centrum)->height =DIA_CANVAS_ELEMENT (item)->height*0.6;
   resto=DIA_CANVAS_ELEMENT (item)->width/5.5;
   DIA_CANVAS_ITEM(cuadroTexto->centrum)->affine[4]=resto;
   resto=DIA_CANVAS_ELEMENT (item)->height/6.5;
   DIA_CANVAS_ITEM(cuadroTexto->centrum)->affine[5]=resto;
	
   if (DIA_CANVAS_ITEM_GET_CLASS (cuadroTexto->textus)->update) 
       {
		gdouble a[6];
		art_affine_multiply (a, affine, cuadroTexto->textus->affine);
		DIA_CANVAS_ITEM_GET_CLASS (cuadroTexto->textus)->update (cuadroTexto->textus,a);
	} else
	g_assert_not_reached ();
	DIA_UNSET_FLAGS (cuadroTexto->textus, DIA_NEED_UPDATE);
	
	if (DIA_CANVAS_ITEM_GET_CLASS (cuadroTexto->textus_bassus)->update) 
	{
	 gdouble a[6];
          art_affine_multiply (a, affine, cuadroTexto->textus_bassus->affine);
         DIA_CANVAS_ITEM_GET_CLASS (cuadroTexto->textus_bassus)->update (cuadroTexto->textus_bassus, a);
           
         } else
	 g_assert_not_reached ();
   	
        DIA_UNSET_FLAGS (cuadroTexto->textus_bassus, DIA_NEED_UPDATE);
   
   if (DIA_CANVAS_ITEM_GET_CLASS (cuadroTexto->centrum)->update) 
	{
	gdouble a[6];
        art_affine_multiply (a, affine, cuadroTexto->centrum->affine);
	DIA_CANVAS_ITEM_GET_CLASS(cuadroTexto->centrum)->update (cuadroTexto->centrum, a);
       } else
	g_assert_not_reached ();
   	        DIA_UNSET_FLAGS (cuadroTexto->centrum, DIA_NEED_UPDATE);
   
         /*Esta fución activa el evento de ratón para el texto*/
             /*this function active mouse event's for the text*/	  
/*	if (DIA_CANVAS_ITEM_VISIBLE (cuadroTexto->textus)) 
              {
		gdouble x1, x2, y1, y2;
		dia_canvas_item_bb_affine (cuadroTexto->textus, cuadroTexto->textus->affine,
					   &x1, &y1, &x2, &y2);

		item->bounds.left = x1;
		item->bounds.top = y1;
		item->bounds.right = x2;
	        item->bounds.bottom = y2;
					
	      } else 
               {
		item->bounds.left = item->bounds.top =
		item->bounds.right = item->bounds.bottom = 0.0;
	       }
  */     
	p2.x = DIA_CANVAS_ELEMENT (cuadroTexto)->width;
	p2.y = DIA_CANVAS_ELEMENT (cuadroTexto)->height;
	medietas = cuadroTexto->perimetros_amplus / 2.0;
	item->bounds.top -= medietas;
	item->bounds.left -= medietas;
	item->bounds.bottom += medietas;
	item->bounds.right += medietas;

	/* Create the border */
	dia_shape_rectangle (cuadroTexto->perimetros, &p1, &p2);
	dia_shape_set_color (cuadroTexto->perimetros, DIA_TEXTUS_CUADRUS (item)->color);
	dia_shape_path_set_fill (cuadroTexto->perimetros, DIA_FILL_SOLID);
	dia_shape_path_set_fill_color (cuadroTexto->perimetros, 0);
        dia_shape_path_set_line_width (cuadroTexto->perimetros, DIA_TEXTUS_CUADRUS (cuadroTexto)->perimetros_amplus);
        if(cuadroTexto->color) 
        dia_shape_set_color (cuadroTexto->perimetros,cuadroTexto->color);   
        else
        dia_shape_set_color (cuadroTexto->perimetros,DIA_COLOR_A (90, 50, 180, 250));


     }
 

/*Establece laas propiedades del elemento
 *Se le pasa como parámetros:
 * El objeto.
 *  El identificador de la propiedad,
 *   La propiedad
 *   La especificación de la propiedad
 * Sets the objects' propierties
 * like: object
 * propierties id.
 * propierties sets.
*/
static void propiedades_textus_cuadrus(GObject* objeto,guint id_propiedad, const GValue* propiedad, GParamSpec* especificacion)
{
	DiaTextusCuadrus* cuadro; /*El representante de este*/
	int valor;
        long valor_l;
        double valor_d;
        char* tex_tus;
	cuadro=(DiaTextusCuadrus*)objeto;		/*Cambio de tipo*/
				  
	switch(id_propiedad)
	{      

               case PROP_TYPUS:  /*La tipografía para la letra*/
			{
 			/*La tipografía del elemento*/	
                  	cuadro->typus=g_value_get_boxed(propiedad); 
                  	g_object_set(DIA_TEXTUS_CUADRUS(objeto)->textus_bassus,"font",
                                      cuadro->typus,NULL);
                  	g_object_set(cuadro->textus,"font",cuadro->typus,NULL);
          	        dia_canvas_item_request_update (DIA_CANVAS_ITEM(objeto));
			}break;	
		 
               case PROP_TAMAGNUS_TYPUS:  /*tamaño de la fuente, ha de ser la primera*/
			{
			 valor=g_value_get_int(propiedad);	
                         cuadro->tamagnus_typus=valor;
			 pango_font_description_set_size(cuadro->typus,valor*PANGO_SCALE_LARGE);
                         dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
			}break;	
		case PROP_NOMENIS:  /*el nombre del cuadro*/
		  {
                   DIA_TEXTUS_CUADRUS(cuadro)->nomenis=(char*)g_value_get_string(propiedad);
		 /*Al cuadro de texto se le pone el valor dado*/  
		   g_object_set(DIA_TEXTUS_CUADRUS(cuadro)->textus,"font",
                                      cuadro->typus,"text",DIA_TEXTUS_CUADRUS(cuadro)->nomenis,
                                      "editable",FALSE,"markup",TRUE,NULL);
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
		  }break;
                  case 	PROP_COLOR: /*Color de la línea del perímetro*/
                  {
                   valor_l=g_value_get_ulong(propiedad);
                   DIA_TEXTUS_CUADRUS(cuadro)->color=valor_l;
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
                  }break;
                  case PROP_PLENUS_COLOR: /*color de relleno del cuadro*/
                  {
		   valor_l=g_value_get_ulong(propiedad);

                   DIA_TEXTUS_CUADRUS(cuadro)->plenus_color=valor_l;
                   g_object_set(DIA_TEXTUS_CUADRUS(objeto)->centrum,"fill_color",
                                DIA_TEXTUS_CUADRUS(cuadro)->plenus_color,NULL);
                  dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto)); 
                  }break;
                  case PROP_PERIMETROS_AMPLUS: /*EL ancho de la línea del perímetro*/
                   {
                    valor_d=g_value_get_double(propiedad);
                    DIA_TEXTUS_CUADRUS(cuadro)->perimetros_amplus=valor_d;    
                    dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
                   }break; 
		  case PROP_TEXTUS:
                   {
                    tex_tus=(char*)g_value_get_string(propiedad);
                    DIA_TEXTUS_CUADRUS(cuadro)->tex_tus=tex_tus;
	            g_object_set(DIA_TEXTUS_CUADRUS(cuadro)->textus,"font",cuadro->typus,
                                "text",DIA_TEXTUS_CUADRUS(cuadro)->tex_tus,
                                "editable",TRUE,NULL);  
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
                  }break;
		default:/*por si se pasa un parámetro que no es*/
			G_OBJECT_WARN_INVALID_PROPERTY_ID(objeto,id_propiedad,propiedad);
			break;
		}//fin del switch
            
	}


/*entrega las propiedades del elemento, el tipo de propiedad valor*/
static void entrega_propiedades_textus_cuadrus(GObject* objeto,guint id_propiedad,GValue* parametros,GParamSpec* especificacion)
{
  DiaTextusCuadrus* cuadro; /*El representante de este*/
  cuadro=(DiaTextusCuadrus*)objeto;		/*Cambio de tipo*/
  switch(id_propiedad)
  {
                case PROP_TYPUS:  /*tipografía*/
		 {
                  g_value_set_boxed(parametros,cuadro->typus); 
		 }break;	
		case PROP_TAMAGNUS_TYPUS:  /*Tamaño del tipo*/
		 {
                 g_value_set_int(parametros,cuadro->tamagnus_typus);
		 }break;	
		case PROP_NOMENIS:  /*el nombre del cuadro*/
		  {
                   g_value_set_string(parametros,DIA_TEXTUS_CUADRUS(cuadro)->nomenis);  
		  }break;
                case PROP_COLOR: /*Color de la línea del perímetro*/
                  {
            	   g_value_set_ulong (parametros, DIA_TEXTUS_CUADRUS(cuadro)->color);
                  }break;
                case PROP_PLENUS_COLOR: /*color de relleno del cuadro*/
                  {
               	   g_value_set_ulong (parametros, DIA_TEXTUS_CUADRUS(cuadro)->plenus_color);
                  }break;
                case PROP_PERIMETROS_AMPLUS: /*EL ancho de la línea del perímetro*/
                   {
		    g_value_set_double (parametros,DIA_TEXTUS_CUADRUS(cuadro)->perimetros_amplus);
                        
                   }break; 
		case PROP_TEXTUS:
                  {
                   g_value_set_string(parametros,DIA_TEXTUS_CUADRUS(cuadro)->tex_tus);
                   }break;
	      default:
              G_OBJECT_WARN_INVALID_PROPERTY_ID(objeto,id_propiedad,especificacion);	  
	 break; 
        }
	
       }	
	

static void dia_textus_cuadrus_groupable_add (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_if_fail (DIA_IS_TEXTUS_CUADRUS (textbox));
}

static void dia_textus_cuadrus_groupable_remove (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_if_fail (DIA_IS_TEXTUS_CUADRUS (textbox));

}
/*La cantidad de elementos es puesto un arreglo de elementos*/
static gboolean dia_textus_cuadrus_groupable_get_iter (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	g_return_val_if_fail (DIA_IS_TEXTUS_CUADRUS (textbox),  FALSE);

	iter->data[0] = DIA_TEXTUS_CUADRUS (textbox)->textus; /*El texto ppal*/
	iter->data[1] = DIA_TEXTUS_CUADRUS (textbox)->textus_bassus;
	iter->data[2] = DIA_TEXTUS_CUADRUS (textbox)->centrum;
	return TRUE;
}


static gboolean dia_textus_cuadrus_get_shape_iter (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	iter->data[0] = DIA_TEXTUS_CUADRUS(item)->perimetros;
	return TRUE;
}

/*Al parecer acá hay que entregar los elementos
* PERO LOS PIDE UNO POR UNO
*  EL PRIMERO QUE SE CREA ES EL QUE ESTÁ POR DEFECTO
* LOS DEMÁ SE VAN INCRUSTANDO A MEDIDA QUE SE VALLANA LLAMANDO
* EL ÚLTIMO VALOS VA SER SIEMPRE NULL, CON FALSE
*/
static gboolean dia_textus_cuadrus_groupable_next (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	DiaTextusCuadrus *cajaTexto;
	cajaTexto  = (DiaTextusCuadrus*)textbox;
	g_return_val_if_fail (DIA_IS_TEXTUS_CUADRUS(textbox),  FALSE);
   	if (iter->data[0] == cajaTexto->textus)
	    {
		iter->data[0] = cajaTexto->textus_bassus;
		return TRUE;	/*como se cambió el valor es verdadero*/
	     } else	
        if(iter->data[0] == cajaTexto->textus_bassus) /*Si es la caja de texto*/
	     {
	      iter->data[0] = cajaTexto->centrum;
	      return TRUE;	/*como se cambió el valor es verdadero*/
	     }
	     iter->data[0] = NULL;
	   return FALSE;       /*COMO YA NO HAY MÁS EL VALOR ES FALSO*/
       }



static gboolean dia_textus_cuadrus_shape_next (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	iter->data[0] = NULL;
	return FALSE;
}



static DiaShape*  dia_textus_cuadrus_shape_value (DiaCanvasItem *item, DiaCanvasIter *iter)
{
	return iter->data[0];
}


/*Es la que entrega c/u de los items pertenecientes al objeto
 * Siempre apuntando al cero 
 */
static DiaCanvasItem* dia_textus_cuadrus_groupable_value (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	DiaTextusCuadrus *cajaTexto;
	int num;
	cajaTexto  = (DiaTextusCuadrus*)textbox;
	g_return_val_if_fail (DIA_IS_TEXTUS_CUADRUS (cajaTexto),  NULL);
   	return iter->data[0];
}
/*La que entrega la cantidad de elementos o de componenets que posee*/
static gint dia_textus_cuadrus_groupable_length (DiaCanvasGroupable *cuadroTexto)
{
	int conta=0;
	g_return_val_if_fail (DIA_IS_TEXTUS_CUADRUS (cuadroTexto),  -1);
    if(DIA_TEXTUS_CUADRUS (cuadroTexto)->textus)
	   conta++;
	if( DIA_TEXTUS_CUADRUS(cuadroTexto)->textus_bassus)
		conta++;
	if( DIA_TEXTUS_CUADRUS(cuadroTexto)->centrum)
		conta++;
	return conta;
}

/*Entrega la posición del elemento que está en la caja*/
static gint dia_textus_cuadrus_groupable_pos (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_val_if_fail (DIA_IS_TEXTUS_CUADRUS (textbox),  -1);
     if(item == DIA_TEXTUS_CUADRUS (textbox)->textus)
		 return 0;
	 else if (item == DIA_TEXTUS_CUADRUS (textbox)->textus_bassus)
		  return 1;
	 else if(item == DIA_TEXTUS_CUADRUS (textbox)->centrum)
		 return 2;
	     return -1;
}

