/***************************************************************************
 *            dia-textus-punctum.c
 *
 *  Wed Sep 27 17:38:31 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/
#include "dia-textus-punctum.h"
#include "dia-canvas-punctum.h"/*El punto*/

#include <libart_lgpl/art_affine.h>
#include "dia-canvas-i18n.h"
#include "dia-canvas-groupable.h"
#include "dia-canvas-text.h"


int tama[2];  /*El arreglo de dos, para el tamaño*/
/*LAS PROPIEDADES DEL CUADRO DE TEXTO*/
/*

*/
enum {
	PROP_TYPUS=1,
	PROP_TEXTUS,
	PROP_TAMAGNUS_TYPUS,	/*EL TAMAÑO DE LA FUENTE*/ /*HAY QUE PONERLO DE PRIMERO */
	PROP_COLOR,		/*COLOR DEL PERÍMETRO*/
	PROP_PLENUS_COLOR,
        PROP_PERIMETROS_AMPLUS   /*ancho de la línea del perímetro*/
	};
										 
static void dia_textus_punctum_init(DiaTextusPunctum *cuadroTexto);
static void dia_textus_punctum_class_init(DiaTextusPunctumClass *klass);
static void dia_textus_punctum_groupable_init(DiaCanvasGroupableIface *groupable);
static void dia_textus_punctum_dispose		(GObject *object);
static void dia_textus_punctum_update		(DiaCanvasItem *item,gdouble affine[6]);
/*Establece laas propiedades del elemento*/
static void propiedades_textus_punctum(GObject* objeto,guint id_propiedad, const GValue* propiedad, GParamSpec* especificacion);
/*entrega las propiedades del cuadro*/
static void entrega_propiedades_textus_punctum(GObject* objeto,guint id_propiedad,GValue* parametros,GParamSpec* especificacion);

/*La función encargada de obtener el tamaño del elemento*/
int* tama_elemento_textus_cuadrus(DiaCanvasElement* cuadro);
	

//static gboolean dia_textbox_event	(DiaCanvasItem *item,
//					 DiaEvent *event);

/* Interface functions: */
static void dia_textus_punctum_groupable_add	(DiaCanvasGroupable *CuadroTexto,DiaCanvasItem *item);
static void dia_textus_punctum_groupable_remove	(DiaCanvasGroupable *CuadroTexto,DiaCanvasItem *item);
static gboolean dia_textus_punctum_groupable_get_iter	(DiaCanvasGroupable *CuadroTexto,DiaCanvasIter *iter);
static gboolean dia_textus_punctum_groupable_next	(DiaCanvasGroupable *CuadroTexto,DiaCanvasIter *iter);
static DiaCanvasItem* dia_textus_punctum_groupable_value (DiaCanvasGroupable *CuadroTexto, DiaCanvasIter *iter);
static gint dia_textus_punctum_groupable_length	(DiaCanvasGroupable *CuadroTexto);
static gint dia_textus_punctum_groupable_pos	(DiaCanvasGroupable *CuadroTexto,DiaCanvasItem *item);

static DiaCanvasElementClass *parent_class = NULL;
/*ES PARA HACER EL OBJETO TAL CUAL gboject y heredar de diacanvas*/
GType dia_textus_punctum_get_type (void)
{
	static GType object_type = 0;

	if (!object_type) {
		static const GTypeInfo object_info = {
			sizeof (DiaTextusPunctumClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) dia_textus_punctum_class_init,
			(GClassFinalizeFunc) NULL,
			(gconstpointer) NULL, /* class_data */
			sizeof (DiaTextusPunctum),
			(guint16) 0, /* n_preallocs */
			(GInstanceInitFunc) dia_textus_punctum_init,
		};
		static const GInterfaceInfo groupable_info = {
			(GInterfaceInitFunc) dia_textus_punctum_groupable_init,
			NULL,
			NULL,
		};
		object_type = g_type_register_static (DIA_TYPE_CANVAS_ELEMENT,
						      "DiaTextusPunctum",
						      &object_info, 0);
		g_type_add_interface_static (object_type,
					     DIA_TYPE_CANVAS_GROUPABLE,
					     &groupable_info);
	}

	return object_type;
}
/*El que inica la clase*/
static void dia_textus_punctum_class_init (DiaTextusPunctumClass *klass)
{
	GObjectClass *object_class;
	DiaCanvasItemClass *item_class;
 
	object_class = (GObjectClass*) klass;
	item_class = DIA_CANVAS_ITEM_CLASS(klass);

	parent_class = g_type_class_peek_parent (klass);

	object_class->dispose = dia_textus_punctum_dispose;
        /*Función que ingresa las propiedades*/
        object_class->set_property=propiedades_textus_punctum;  
        /*función que entrega los parámetrios*/
        object_class->get_property=entrega_propiedades_textus_punctum; 
	
	item_class->update = dia_textus_punctum_update;
	
	/*g_object_class_install_property (object_class,
					 PROP_FONT,
					 g_param_spec_boxed ("font",
						_("Font description"),
						_(""),
						PANGO_TYPE_FONT_DESCRIPTION,
						G_PARAM_WRITABLE));
	g_object_class_install_property (object_class,
					 PROP_TEXT,
					 g_param_spec_string ("text",
						_("Text"),
						_("Text to be displayed"),
						NULL,
						G_PARAM_READWRITE));
	*/

   /*ancho de la línea del perímetro
    */
  g_object_class_install_property(object_class,PROP_TAMAGNUS_TYPUS,g_param_spec_int("tamaño","Tamaño","Tamaño de la fuente",G_MININT,G_MAXINT,0,G_PARAM_READWRITE));
        /*english*/
        g_object_class_install_property(object_class,PROP_TAMAGNUS_TYPUS,g_param_spec_int("size",_("Size"),_("Font size"),G_MININT,G_MAXINT,0,G_PARAM_READWRITE));
	
  	/*
         *La propiedad de nombre de función del elemento
         * ITEMS NAME
         */
	
/*Users text*/
         g_object_class_install_property(object_class,PROP_TEXTUS,
                                        g_param_spec_string("textus","Textus",
                                        "textus",NULL,G_PARAM_READWRITE));
         g_object_class_install_property(object_class,PROP_TEXTUS,
                                         g_param_spec_string("text","Text",
                                         "text usr",NULL,G_PARAM_READWRITE));

		
	
       g_object_class_install_property (object_class,
					 PROP_COLOR,
					 g_param_spec_ulong ("color",
						_("Color"),
						_("RGBA"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));
	
       g_object_class_install_property (object_class,
					 PROP_PLENUS_COLOR,
					 g_param_spec_ulong ("fill_color",
						_("Fill color"),
						_("Fill color"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));

       g_object_class_install_property (object_class,
					 PROP_PLENUS_COLOR,
					 g_param_spec_ulong ("plenus_color",
						_("Color de relleno"),
						_("Color de relleno"),
						0, G_MAXULONG, 0,
						G_PARAM_READWRITE));

	g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("border_width",
						_("Border width"),
						_("width of the border"),
						-G_MAXDOUBLE, G_MAXDOUBLE, 0.0,
						G_PARAM_READWRITE));
	
	g_object_class_install_property (object_class,
					 PROP_PERIMETROS_AMPLUS,
					 g_param_spec_double ("perimetros_amplus",
						"Ancho de la marca del perímetro",
						"perimetros amplus",
						-G_MAXDOUBLE, G_MAXDOUBLE, 0.0,
						G_PARAM_READWRITE));

				
			
}
/* El que incia la interfaz de agrupación*/
static void dia_textus_punctum_groupable_init (DiaCanvasGroupableIface *groupable)
{
	groupable->add = dia_textus_punctum_groupable_add;
	groupable->remove = dia_textus_punctum_groupable_remove;
	groupable->get_iter = dia_textus_punctum_groupable_get_iter;
	groupable->next = dia_textus_punctum_groupable_next;
	groupable->value = dia_textus_punctum_groupable_value;
	groupable->length = dia_textus_punctum_groupable_length;
	groupable->pos = dia_textus_punctum_groupable_pos;
}

/*Inicia el objeto diatextbox*/
static void dia_textus_punctum_init (DiaTextusPunctum* textusPunctum)
{ 
	int* tama; /*El tamaño del  ancho objeto es la pos 0, alto la pos 1*/
	int ancho, alto;
        /*La tipografía*/
        textusPunctum->typus=pango_font_description_new(); /*La fuente del elemento*/
	pango_font_description_set_size(textusPunctum->typus,6500*PANGO_SCALE_LARGE);
	/*Es el texto superior de la imagen, el que indica el tipo de elemento que es*/
	textusPunctum->textus = dia_canvas_item_create (DIA_TYPE_CANVAS_TEXT, NULL);
         /*Hijo del componente ppal, textbox*/
	dia_canvas_item_set_child_of (textusPunctum->textus, DIA_CANVAS_ITEM (textusPunctum));
       	g_object_set(DIA_TEXTUS_PUNCTUM(textusPunctum)->textus,"font",
                                       textusPunctum->typus,"text","nudo","editable",FALSE,NULL);  
	dia_canvas_item_move(textusPunctum->textus,0,0); 
        /*
         * El punto ;)
         * Con los valores por defecto
         */
	textusPunctum->centrum=dia_canvas_item_create(dia_canvas_punctum_get_type(),
                                                    "color",DIA_COLOR_A(50,120,10,200),
                                                   "plenus_color",DIA_COLOR_A(20,120,10,200),NULL);
        
        /*hijo de este componente*/
	dia_canvas_item_set_child_of(textusPunctum->centrum,DIA_CANVAS_ITEM(textusPunctum));  
  	dia_canvas_item_move(textusPunctum->centrum,20/5,20/5);
//	g_object_set (textusPunctum,"resizable",FALSE,NULL);
        
  }
  
/*La función para el tamaño del elemento*/
 int* tama_elemento_textus_punctum(DiaCanvasElement* textusPunctum)
	{
		/*El primer valor es el ancho, el segundo es el alto*/
		tama[0]=(int)DIA_CANVAS_ELEMENT (textusPunctum)->width;	
		tama[1]=(int)DIA_CANVAS_ELEMENT (textusPunctum)->height;
		return tama;
	}
 
  
/*Entrega la memoria ocupada de los elementos al sistema*/
static void dia_textus_punctum_dispose (GObject *object)
{
	DiaTextusPunctum* textusPunctum = (DiaTextusPunctum*) object;
	if (textusPunctum->textus) 
               {   /*libera el primer texto, el que describe el elemento*/
		g_object_unref (textusPunctum->textus);
		textusPunctum->textus = NULL;
	       }
	if(textusPunctum->centrum)
	   {
		g_object_unref (textusPunctum->centrum); /*componente central*/
		textusPunctum->centrum = NULL;
	   }	  
	G_OBJECT_CLASS (parent_class)->dispose (object);
}

/*Actualiza la cja de texto*/
static void dia_textus_punctum_update (DiaCanvasItem *item, gdouble affine[6])
{
	DiaTextusPunctum* textusPunctum;
	double radius;	
	g_return_if_fail(item != NULL);
	g_return_if_fail(DIA_IS_TEXTUS_PUNCTUM(item));
	
	//g_message (G_STRLOC);

	DIA_CANVAS_ITEM_CLASS (parent_class)->update (item, affine);
	textusPunctum = DIA_TEXTUS_PUNCTUM(item);
        /*
         *Si el cuadro central ha sido seleccionado
         * If center box has been selected
         */
        if( dia_canvas_item_is_selected(DIA_CANVAS_ITEM(textusPunctum->centrum)))
	  { 
	    //dia_canvas_item_unselect(DIA_CANVAS_ITEM(textusPunctum->centrum));  
	    //dia_canvas_item_select(DIA_CANVAS_ITEM(textusPunctum));
	  }	

        radius=(DIA_CANVAS_ELEMENT (item)->width+DIA_CANVAS_ELEMENT (item)->height)/2;
	DIA_CANVAS_PUNCTUM(textusPunctum->centrum)->radius=radius;
        DIA_CANVAS_ELEMENT (item)->width=DIA_CANVAS_PUNCTUM(textusPunctum->centrum)->radius;
        DIA_CANVAS_ELEMENT (item)->height=DIA_CANVAS_PUNCTUM(textusPunctum->centrum)->radius;

         
	DIA_CANVAS_TEXT (textusPunctum->textus)->width = DIA_CANVAS_ELEMENT (item)->width;
	DIA_CANVAS_TEXT (textusPunctum->textus)->height = DIA_CANVAS_ELEMENT (item)->height;

    
	
 if (DIA_CANVAS_ITEM_GET_CLASS (textusPunctum->textus)->update) 
        {
	gdouble a[6];
	art_affine_multiply (a, affine, textusPunctum->textus->affine);
	//g_message ("%f %f %f %f %f %f",
	//	   a[0], a[1], a[2],  a[3], a[4], a[5]);
	DIA_CANVAS_ITEM_GET_CLASS (textusPunctum->textus)->update(textusPunctum->textus, a);
	}else
	  g_assert_not_reached ();
       DIA_UNSET_FLAGS (textusPunctum->textus, DIA_NEED_UPDATE);
	
	
   if (DIA_CANVAS_ITEM_GET_CLASS (textusPunctum->centrum)->update) 
	{
	 gdouble a[6];
	 DIA_CANVAS_ITEM_GET_CLASS(textusPunctum->centrum)->update (textusPunctum->centrum, a);
       } else
	g_assert_not_reached ();
   	DIA_UNSET_FLAGS (textusPunctum->centrum, DIA_NEED_UPDATE);
   
   
   /*Esta fución activa el evento de ratón para el texto*/
	  
	if (DIA_CANVAS_ITEM_VISIBLE (textusPunctum->textus)) 
               {
		gdouble x1, x2, y1, y2;
		dia_canvas_item_bb_affine (textusPunctum->textus, textusPunctum->textus->affine,
					   &x1, &y1, &x2, &y2);
		item->bounds.left = x1;
		item->bounds.top = y1;
		item->bounds.right = x2;
	        item->bounds.bottom = y2;
					
	} else {
		item->bounds.left = item->bounds.top =
		item->bounds.right = item->bounds.bottom = 0.0;
		}
	
}
 
#if 0   /*eventos para la caja de texto*/
static gboolean dia_textus_punctum_event (DiaCanvasItem *item, DiaEvent *event)
{
	/* Request updates for the text at some events. */
	switch (event->type) {
	case DIA_EVENT_BUTTON_PRESS:
		if (event->button.button == 1) {
			dia_canvas_item_request_update (DIA_TEXTUS_PUNCTUM (item)->textus);
			dia_canvas_item_request_update (DIA_TEXTUS_PUNCTUM (item)->centro);
			printf("evento 1\n");
			dia_canvas_item_unfocus(DIA_TEXTUS_CUADRUS (item)->centro);
		}
		break;
	case DIA_EVENT_BUTTON_RELEASE:
		if (DIA_CANVAS_ITEM_GRAB (item)) {
			dia_canvas_item_request_update (DIA_TEXTUS_PUNCTUM (item)->textus);
			/*dia_canvas_item_request_update (DIA_TEXTUS_PUNCTUM (item)->centro);*/
			}
		break;
	case DIA_EVENT_MOTION:
		if (DIA_CANVAS_ITEM_GRAB (item)) {
			dia_canvas_item_request_update (DIA_TEXTUS_PUNCTUM (item)->textus);
			/*dia_canvas_item_request_update (DIA_TEXTUS_CUADRUS (item)->centro);*/
		  }
	default:
		break;
	}
	return DIA_CANVAS_ITEM_CLASS (parent_class)->event (item, event);
}
#endif



/*Establece laas propiedades del elemento
 *Se le pasa como parámetros:
 * El objeto.
 *  El identificador de la propiedad,
 *   La propiedad
 *   La especificación de la propiedad
 * las posible propiedades son:

*/
static void propiedades_textus_punctum(GObject* objeto,guint id_propiedad, const GValue* propiedad, GParamSpec* especificacion)
{
	DiaTextusPunctum* textusPunctum; /*El representante de este*/
	int valor;
        long valor_l;
        double valor_d;
        char* tex_tus;
	textusPunctum=(DiaTextusPunctum*)objeto;		/*Cambio de tipo*/
   printf("entro propiedades punctum propiedad : %d\n",id_propiedad);  
    switch(id_propiedad)
	{  
             case PROP_TAMAGNUS_TYPUS:
                   {
                   }break;
             case PROP_TEXTUS:
                   {
                    tex_tus=(char*)g_value_get_string(propiedad);
                    textusPunctum->tex_tus=tex_tus;
	            g_object_set(textusPunctum->textus,"font",textusPunctum->typus,
                                "text",textusPunctum->tex_tus,
                                "editable",FALSE,NULL);  
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
                  }break;
		case PROP_COLOR: /*Color de la línea del perímetro*/
                  {
                   g_object_set(DIA_CANVAS_PUNCTUM(textusPunctum->centrum),"color",
                                                   g_value_get_ulong(propiedad),NULL);
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto));
                  }break;
                case PROP_PLENUS_COLOR:
		  {
		    g_object_set(DIA_CANVAS_PUNCTUM(textusPunctum->centrum),"plenus_color",
                                 g_value_get_ulong(propiedad),NULL);
                  dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto)); 
                  }break;
                case PROP_PERIMETROS_AMPLUS:
                  {
                    g_object_set(DIA_CANVAS_PUNCTUM(textusPunctum->centrum),"perimetros_amplus",
                                 g_value_get_double(propiedad),NULL);
                   dia_canvas_item_request_update (DIA_CANVAS_ITEM (objeto)); 
                  }break;
                default:/*por si se pasa un parámetro que no es*/
			G_OBJECT_WARN_INVALID_PROPERTY_ID(objeto,id_propiedad,propiedad);
		        break;
		}//fin del switch
	}


/*entrega las propiedades del elemento, el tipo de propiedad valor*/
static void entrega_propiedades_textus_punctum(GObject* objeto,guint id_propiedad,GValue* parametros,GParamSpec* especificacion)
{
  DiaTextusPunctum* textusPunctum; /*El representante de este*/
  textusPunctum=(DiaTextusPunctum*)objeto;		/*Cambio de tipo*/
  switch(id_propiedad)
  {
	 case PROP_TAMAGNUS_TYPUS:  /*tamaño de la fuente, ha de ser la primera*/
		 {
        printf("entro obtener propiedades 1 \n");  
		 }break;	
         case PROP_COLOR: /*Color de la línea del perímetro*/
               {
        printf("entro obtener propiedades 2 \n");  
      	        g_value_set_ulong (parametros, DIA_CANVAS_PUNCTUM(textusPunctum->centrum)->color);
               }break;
         case PROP_PLENUS_COLOR: /*color de relleno del cuadro*/
                {
        printf("entro obtener propiedades 3 \n");  
                g_value_set_ulong (parametros,
                                   DIA_CANVAS_PUNCTUM(textusPunctum->centrum)->plenus_color);
                }break;
         case PROP_PERIMETROS_AMPLUS: /*EL ancho de la línea del perímetro*/
                {
        printf("entro obtener propiedades 4 \n");  
	        g_value_set_double (parametros,
                                    DIA_CANVAS_PUNCTUM(textusPunctum->centrum)->perimetros_amplus);
                }break; 
	case PROP_TEXTUS:
               {
        printf("entro obtener propiedades 5 \n");  
               g_value_set_string(parametros,textusPunctum->tex_tus);
               }break;
       default:
               G_OBJECT_WARN_INVALID_PROPERTY_ID(objeto,id_propiedad,especificacion);	  
	 break; 
  }
	
}	
	

static void dia_textus_punctum_groupable_add (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_if_fail (DIA_IS_TEXTUS_PUNCTUM (textbox));
}

static void dia_textus_punctum_groupable_remove (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
	g_return_if_fail (DIA_IS_TEXTUS_PUNCTUM (textbox));
	//return FALSE;
}
/*La cantidad de elementos es puesto un arreglo de elementos*/
static gboolean dia_textus_punctum_groupable_get_iter (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	g_return_val_if_fail (DIA_IS_TEXTUS_PUNCTUM (textbox),  FALSE);
        printf("entro groupable get iter\n");  
	iter->data[0] = DIA_TEXTUS_PUNCTUM (textbox)->textus;
	iter->data[1] = DIA_TEXTUS_PUNCTUM (textbox)->centrum; 
	return TRUE;
}

/*Al parecer acá hay que entregar los elementos
* PERO LOS PIDE UNO POR UNO
*  EL PRIMERO QUE SE CREA ES EL QUE ESTÁ POR DEFECTO
* LOS DEMÁ SE VAN INCRUSTANDO A MEDIDA QUE SE VALLANA LLAMANDO
* EL ÚLTIMO VALOS VA SER SIEMPRE NULL, CON FALSE
*/
static gboolean dia_textus_punctum_groupable_next (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	DiaTextusPunctum *cajaTexto;
	cajaTexto  = (DiaTextusPunctum*)textbox;
        printf("entro groupable next \n");  
	g_return_val_if_fail (DIA_IS_TEXTUS_PUNCTUM(textbox),  FALSE);
   	if (iter->data[0] == cajaTexto->textus)
	    {
	     iter->data[0] = cajaTexto->centrum;
	     return TRUE;	/*como se cambió el valor es verdadero*/
	    } else
	     iter->data[0] = NULL;
	   return FALSE;  /*COMO YA NO HAY MÁS EL VALOR ES FALSO*/
   }
/*Es la que entrega c/u de los items pertenecientes al objeto
 * Siempre apuntando al cero 
 */
static DiaCanvasItem* dia_textus_punctum_groupable_value (DiaCanvasGroupable *textbox, DiaCanvasIter *iter)
{
	DiaTextusPunctum *cajaTexto;
	int num;
        printf("entro groupable value\n");  
	cajaTexto  = (DiaTextusPunctum*)textbox;
	g_return_val_if_fail (DIA_IS_TEXTUS_PUNCTUM (cajaTexto),  NULL);
   	return iter->data[0];
}
/*La que entrega la cantidad de elementos o de componenets que posee*/
static gint dia_textus_punctum_groupable_length (DiaCanvasGroupable *cuadroTexto)
{
	int conta=0;
	g_return_val_if_fail (DIA_IS_TEXTUS_PUNCTUM (cuadroTexto),  -1);
        printf("entro groupable length\n");  
    if(DIA_TEXTUS_PUNCTUM (cuadroTexto)->textus)
	   conta++;
    if( DIA_TEXTUS_PUNCTUM(cuadroTexto)->centrum)
	  conta++;
	return conta;
}

/*Entrega la posición del elemento que está en la caja*/
static gint dia_textus_punctum_groupable_pos (DiaCanvasGroupable *textbox, DiaCanvasItem *item)
{
     g_return_val_if_fail (DIA_IS_TEXTUS_PUNCTUM (textbox),  -1);
     if(item == DIA_TEXTUS_PUNCTUM (textbox)->textus)
		 return 0;
     else if(item == DIA_TEXTUS_PUNCTUM (textbox)->centrum)
		 return 1;
	     return -1;
}
